//============================================================================
//	apci8133w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/05/27
//
//============================================================================
#include <windows.h>
#include <tchar.h>
#include "apci8133w.h"	// aPCI-8133

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
static BOOL Apci8133wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL ߰Ċ֐ڽ̊i[ϐ
static FARPROC pApci8133GetVersion = NULL;
static FARPROC pApci8133Create = NULL;
static FARPROC pApci8133Close = NULL;
static FARPROC pApci8133GetResource = NULL;
static FARPROC pApci8133OutPort = NULL;
static FARPROC pApci8133GetLastError = NULL;
static FARPROC pApci8133GetSwitchValue = NULL;

//============================================================================
// 	  apci8133.dll۰(۰ގʹװƂ)	
// 	  
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI8133_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci8133wGetDllExportFunc();
			if (TRUE != Result)
				Apci8133wDllClose();	// DLL֐擾ɎŝDLL۰
		}
	}
	return Result;
}
//============================================================================
// 	  apci8133.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
//============================================================================
// 	  aPCI-8133 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8133GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
//============================================================================
// 	  aPCI-8133̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8133Create)(pwLogSlot);
	return Result;
}
//============================================================================
// 	  aPCI-8133̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8133Close)(wLogSlot);
	return Result;
}
//============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wGetResource(WORD wLogSlot, PAPCI8133R pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8133GetResource)(wLogSlot, pResInfo);
	return Result;
}
//============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8133OutPort)(wLogSlot, dwLogPort, bOutValue);
	return Result;
}
//============================================================================
// 	  aPCI-8133̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
DWORD Apci8133wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL) {
		return APCI8133_ERR_WRAPDLL;
	}
	return (*pApci8133GetLastError)(wLogSlot);
}
//============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
//    pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci8133wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci8133GetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
//--------------------------------------------------------------------------*/
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci8133wGetDllExportFunc()
{
	// Apci8133GetVersion ̱ڽ擾
	pApci8133GetVersion = GetProcAddress(hDLL, _T("Apci8133GetVersion"));
	if (pApci8133GetVersion == NULL)
		return FALSE;

	// Apci8133Create ̱ڽ擾
	pApci8133Create = GetProcAddress(hDLL, _T("Apci8133Create"));
	if (pApci8133Create == NULL)
		return FALSE;

	// Apci8133Close ̱ڽ擾
	pApci8133Close = GetProcAddress(hDLL, _T("Apci8133Close"));
	if (pApci8133Close == NULL)
		return FALSE;

	// Apci8133GetResource ̱ڽ擾
	pApci8133GetResource = GetProcAddress(hDLL, _T("Apci8133GetResource"));
	if (pApci8133GetResource == NULL)
		return FALSE;

	// Apci8133OutPort ̱ڽ擾
	pApci8133OutPort = GetProcAddress(hDLL, _T("Apci8133OutPort"));
	if (pApci8133OutPort == NULL)
		return FALSE;

	// Apci8133GetLastError ̱ڽ擾
	pApci8133GetLastError = GetProcAddress(hDLL, _T("Apci8133GetLastError"));
	if (pApci8133GetLastError == NULL)
		return FALSE;

	// Apci8133GetSwitchValue ̱ڽ擾
	pApci8133GetSwitchValue = GetProcAddress(hDLL, _T("Apci8133GetSwitchValue"));
	if (pApci8133GetSwitchValue == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL ߰Ċ֐ڽ擾
}
