VERSION 5.00
Begin VB.Form Sample 
   Caption         =   "Sample"
   ClientHeight    =   1005
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2085
   LinkTopic       =   "Form1"
   ScaleHeight     =   1005
   ScaleWidth      =   2085
   StartUpPosition =   3  'Windows ̊l
End
Attribute VB_Name = "Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*****************************************************************************
'*                                                                           *
'* aPCI-8133                                                             *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1999/05/27                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szTitle = "Sample"
Private Const sz8133 = "aPCI-8133"

Private Sub Form_Load()
    
    Dim strbuf As String
    Dim dwDllVer As Long, dwDriverVer As Long
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim b As Byte
    Dim ri As APCI8133RESOURCE          ' \[X
    Dim sw As Long                      ' [^XCb`

'---------------------------------------------------------------------------
    ' apci8133.dll ̎gp錾
    If Apci8133wDllOpen() = False Then
        ErrorMessage (APCI8133_SLOT_AUTO)
        Exit Sub                ' apci8133.dll ۰ނɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Apci8133wGetVersion(dwDllVer, dwDriverVer) = False Then ' aPCI-8133DLL,޲ײންޮݔԍ擾
        ErrorMessage (APCI8133_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL    Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Driver Version: &H" + Hex(dwDriverVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-8133̎gp錾
    wLogSlot = APCI8133_SLOT_AUTO     ' gp̃foCXT܂B

    ' ꍇA̎̃foCXi[܂B
    bResult = Apci8133wCreate(wLogSlot)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (APCI8133_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aPCI-8133 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Apci8133wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + sz8133 + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(2)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(2)) + _
             "-&H" + Hex(ri.dwIOPortBase(2) + ri.dwIOPortLength(2) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' [^XCb`̒l擾
    If Apci8133wGetSwitchValue(wLogSlot, sw) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Sw: " + Hex(sw)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Port 1 ɔCӂ̃f[^o
    ' &HAA -> 10101010
    b = &HAA

    If Apci8133wOutPort(wLogSlot, APCI8133_PORT_1, b) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port 1 փf[^o" + Chr(10) + _
             "Port 1 Out Data: &H" + Hex(b)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-8133̎gpJ
    If Apci8133wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aPCI-8133 Closed")

'---------------------------------------------------------------------------
    ' apci8133.dll ̎gpJ
    If Apci8133wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' apci8133.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Integer
    Dim szbuf As String

    dwRes = Apci8133wGetLastError(wLogSlot)

    Select Case dwRes
    Case APCI8133_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    
    Case APCI8133_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else
        szbuf = "aPCI-8133 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub



